Swipp = {
	Trade: {
		create: function(doc) {
			var trade = Object.create(this);
			trade.ts = Date.now();
			var a = $(doc).find('#super-container'), b, c;
			b = a.find('span.kkcount-down10[time]');
			trade.endTime = Number($(b).attr('time'));
			b = b.parent().children('div').children('div');
			$(b[1]).find('a.clue[rel]').each(function(i, a) {
				c = Item.extract(a);
				trade.item = c;
				if (!c.swippMats) c.swippMats = {};
			});
			c = trade.item;
			trade.needed = {};
			$(b[3]).find('a.clue[rel]').each(function(i, a) {
				var item = Item.extract(a);
				trade.needed[item.id] = item;
				var b = Number($(a).parent().text().trim());
				c.swippMats[item.id] = b;
				if (!item.swipp) item.swipp = {};
				item.swipp[c.id] = b;
				item.save();
			});
			c.save();
			return trade;
		},
	},
	
	alarmName: "Swipp",
	swippPage: "/main.php?p=tradepost&lot=swap",
	_lastTrade: null,
	tradeNotif: false,
	_resetAlarm: function() {
		chrome.alarms.get(this.alarmName, function(alarm) {
			Swipp.displayNotification();
			chrome.alarms.create(Swipp.alarmName, {
				when: (Swipp.lastTrade.endTime + 30) * 1000,
				periodInMinutes: 20,	// New Swipp trade every 2 hrs
			});
		});
	},
	getSwipp: function(callback) {
		$.ajax({
			type: "GET",
			url: HOST+this.swippPage,
		}).done(function(html) {
			try {
				var doc = htmlParse(html, true);
				var trade = Swipp.Trade.create(doc);
				var lastT = Swipp.lastTrade;
				if (!lastT || lastT.endTime != trade.endTime) {
					// New Trade!
					Swipp.lastTrade = trade;
				}
				if (callback) callback(trade);
			} catch(e) {
				chrome.alarms.create(Swipp.alarmName, {delayInMinutes: 5, periodInMinutes: 20});
			}
		});
	},
	get lastTrade() {
		return this._lastTrade;
	},
	set lastTrade(trade) {
		this._lastTrade = trade;
		this.tradeNotif = false;
		this._resetAlarm();
	},
	displayNotification: function(force) {
		if (Swipp.tradeNotif && !force) return;
		var trade = Swipp.lastTrade;
		if (!trade) return;
		chrome.notifications.create(Swipp.alarmName, {
			type: "basic",
			title: "Swipp's Swap",
			iconUrl: HOST+trade.item.img,
			message: '"'+trade.item.name+'" is available for trade!',
			eventTime: trade.ts,
			buttons: [{title: "Visit Swipp"},],
		}, function() {
			Swipp.tradeNotif = true;
		});
	},
};

chrome.alarms.onAlarm.addListener(function(alarm) {
	switch(alarm.name) {
		case Swipp.alarmName:
			Swipp.getSwipp();
			break;
	}
});

chrome.notifications.onButtonClicked.addListener(function(nId, bI) {
	if (nId != Swipp.alarmName) return;
	switch(bI) {
		case 0:
			chrome.tabs.create({
				url: HOST+Swipp.swippPage,
				active: true,
			});
			break;
	}
});

chrome.alarms.clear(Swipp.alarmName);
Swipp.getSwipp();