HOST = location.origin;

General = {
	feedAll: function(callback) {
		// Feed all dragons
		$.ajax({
			type: "POST",
			url: HOST+"/includes/ol/feed.php",
			data: "",
		}).done(function(html) {
			if (callback) callback();
		});
	},
	updateMailAlerts: function(callback) {
		// Update mail alert count
		// callback(count)
		$.ajax({
			type: "POST",
			data: "",
			url: HOST+"/includes/ol/mess_alert_count.php",
		}).done(function(html) {
			_Internal.uploadAlerts({mail: html});
			var a = $("#messalert").html(html).text().trim();
			if (callback) callback(a);
		});
	},
	updateNoteAlerts: function(callback) {
		// Update notification alert count
		// callback(count)
		$.ajax({
			type: "POST",
			data: "",
			url: HOST+"/includes/ol/alert_count.php",
		}).done(function(html) {
			_Internal.uploadAlerts({note: html});
			var a = $("#alertm").html(html).text().trim();
			if (callback) callback(a);
		});
	},
}

_Internal = {
	uploadFood: function(data) {
		if (!data) {
			var a = $('#food_bar').find('img[src]');
			if (a.length) {
				data = {
					food: {},
				};
				a.each(function(i, a) {
					var b = $(a);
					c = b.attr('src').match(/\/images\/layout\/icon_([^.]+)\.png/);
					if (c) data.food[c[1]] = b.parent().text().trim();
				});
			}
		}
		if (data) {
			data.request = "food";
			chrome.runtime.sendMessage(data);
		}
	},
	uploadAlerts: function(data) {
		if (!data) data = {
			mail: $("#messalert").html(),
			note: $("#alertm").html(),
		}
		if (data) {
			data.request = "alerts";
			chrome.runtime.sendMessage(data);
		}
	},
	
}

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
	switch(request.request) {
		case "alerts":
			console.log("Alert update received!");
			if (request.mail) $("#messalert").html(request.mail);
			if (request.note) $("#alertm").html(request.note);
			sendResponse();
			break;
		case "food":
			var a = $("#food_bar").find("img[src]");
			if (a.length) {
				console.groupCollapsed("Food update received!");
				console.log(request);
				a.each(function(i, a) {
					var b = $(a);
					var c = b.attr('src').match(/\/images\/layout\/icon_([^.]+)\.png/);
					if (c && request.food[c[1]]) {
						var value = request.food[c[1]];
						console.log(c[1]+": "+value);
						b.parent().contents()[2].data = "\n\t"+value+"\n\t";
					}
				});
				console.groupEnd();
			}
			sendResponse();
			break;
		default:
			console.groupCollapsed("Unknown request received:");
			console.debug(request);
			console.groupEnd();
	}
});

$(function() {
	// _Internal.uploadAlerts();
	// _Internal.uploadFood();
});