(function() {
	var matchPacketName = "qcmQClCSmXc";
	var socket = null;
	for (var i=0;i<sockets.length;i++) {
		if (sockets[i].socket.options.resource == "jigsaw/socket.io") {
			socket = sockets[i];
			break;
		}
	}
	if (socket == null) return;
	
	var cheatList = $("<ul></ul>").appendTo($("<div class='cheat'><b>Cheats:</b></div>").appendTo($("#super-container")));
	function addCheatItem(a) {
		return $("<li></li>").append(a).appendTo(cheatList);
	}
	(function() {
		// Mode buttons
		var cheatMode = null;
		var modeButtons = {};
		function changeMode(newMode) {
			if (cheatMode == newMode) {
				cheatMode = null;
			} else {
				cheatMode = newMode;
			}
			for (var key in modeButtons) {
				var a = modeButtons[key].name;
				if (key == cheatMode) {
					a += " (Active)";
				}
				modeButtons[key].text(a);
			}
		}

		// Spread mode (Spreads pieces evenly)
		var spreadButton = $(document.createElement("button")).click(function(evt) {
			changeMode('spread');
			evt.preventDefault();
			return false;
		});
		spreadButton.name = "Spread Mode";
		modeButtons['spread'] = spreadButton;

		// Easy mode (Pieces are arranged in order)
		var easyButton = $(document.createElement("button")).click(function(evt) {
			changeMode('easy');
			evt.preventDefault();
			return false;
		});
		easyButton.name = "Easy Mode";
		modeButtons['easy'] = easyButton;

		function arrangePieces(data, mode) {
			var pieces = data.lfldfj1FFdd;
			var width = data.KkljkHGkl;
			var height = pieces.length / width;
			var a = Math.floor(450 / height);
			var b = Math.floor(630 / width);
			if (mode == 'spread') {
				var oldOrder = pieces.slice();
				var newOrder = [];
				while (oldOrder.length > 0) {
					var c = Math.floor(Math.random()*oldOrder.length);
					newOrder.push(oldOrder[c]);
					oldOrder.splice(c, 1);
				}
				pieces = newOrder;
			}
			for (var i=0;i<pieces.length;i++) {
				var piece = pieces[i];
				piece.y = 15 + a * (i % height);
				piece.x = 15 + b * Math.floor(i / height);
			}
		}

		socket.addReceiveHandler("dd1j12d12", "cheatMode", function(s, a) {
			var data = a.args[0];
			switch(cheatMode) {
				case "spread":
				case "easy":
					arrangePieces(data, cheatMode);
					break;
			}
		});

		changeMode();
		for (var key in modeButtons) {
			addCheatItem(modeButtons[key]);
		}
	})();

	(function() {
		var running = false;
		var nextReady = 0;
		var board = null;
		var falseStart = false;

		var Piece = function(piece, x, y) {
			this.name = piece.i;
			this.x = x;
			this.y = y;
		};
		var Part = function(manager, pieces) {
			this.manager = manager;
			this.pieces = pieces;
		};
		Part.prototype.join = function(part) {
			if (this == part) return false;
			var pieces = this.pieces;
			var pieces2 = part.pieces;
			var joined = false;
			for (var i=0;i<pieces.length;i++) {
				var piece = pieces[i];
				for (var j=0;j<pieces2.length;j++) {
					var x = piece.x - pieces2[j].x;
					var y = piece.y - pieces2[j].y;
					if (x == 0 && (y == -1 || y == 1)) {
						joined = true;
						socket.emit(matchPacketName, [piece.name, pieces2[j].name]);
					} else if (y == 0 && (x == -1 || x == 1)) {
						joined = true;
						socket.emit(matchPacketName, [piece.name, pieces2[j].name]);
					}
				}
			}
			if (joined) {
				for (var i=0;i<part.pieces.length;i++) {
					this.pieces.push(part.pieces[i]);
				}
			}
			return joined;
		};
		var PieceManager = function (packet) {
			this.pieces = packet.lfldfj1FFdd;
			this.width = packet.KkljkHGkl;
			this.height = Math.ceil(this.pieces.length/this.width);
			this.parts = [];
			for (var i=0;i<this.pieces.length;i++) {
				var a = new Piece(this.pieces[i], Math.floor(i / this.height), i % this.height);
				this.parts.push(new Part(this, [a]));
			}
		};
		PieceManager.prototype.join = function(i, i2) {
			var part = this.parts[i];
			var part2 = this.parts[i2];
			if (part.join(part2)) {
				this.parts.splice(i2,1);
				return true;
			}
		}
		var finishBtn = $(document.createElement("button")).text("Auto-play").click(function(evt){
			if (!running) {
				if (board == null) {
					alert("Start a puzzle first!");
				} else if (falseStart) {
					alert("You have already solved some pieces!\nAuto-player can't handle incomplete puzzles (yet).")
				} else {
					var i = -1;
					var i2 = -1;
					var j = {};
					var k = 0;
					running = setInterval(function() {
						if (nextReady > 0) {
							nextReady -= 1;
							return;
						}
						var a = board.parts.length;
						if (a > 1) {
							if (i < 0) {
								i = Math.floor(Math.random()*a);
								console.log("Locating match for piece: "+i);
								i2 = i;
								j = {}
								k = 0;
							}
							do {
								j[i2] = true;
								i2 = Math.floor(Math.random()*a);
							} while (j[i2]);
							k++;
							if (board.join(i, i2)) {
								nextReady = 10 + Math.floor(Math.random()*5);
								i = -1;
								k = 0;
							}
						} else {
							clearInterval(running);
							running = false;
						}
						var y = board.parts.length - 1;
						var x = board.pieces.length - 1;
						var z = "Working... (";
						z += x-y;
						z += "/";
						z += x;
						z += " | ";
						z += k;
						z += "/";
						z += y;
						z += ")";
						finishBtn.text(z);
					}, 150+Math.random()*75);
				}
			} else {
				alert("Already solving the puzzle! Please wait...");
			}
			finishBtn.attr("disabled", true);
			evt.preventDefault();
			return false;
		});
		socket.addSendHandler("qcmQClCSmXc", "finish", function(s, a) {
			falseStart = true;
		})
		socket.addReceiveHandler("dd1j12d12", "finish", function(s, a) {
			board = new PieceManager(a.args[0]);
			finishBtn.attr("disabled", false);
			falseStart = false;
		});
		socket.addReceiveHandler("dm2j-d2-awd2", "finish", function(s, a) {
			if (running) {
				clearInterval(running);
				running = false;
			}
			board = null;
			finishBtn.attr("disabled", false);
			falseStart = false;
		});
		addCheatItem(finishBtn);
	})();
})();
