function CrossScriptConnection(name) {
	var conn = this;
	conn.name = name;
	conn.listeners = {};
	window.addEventListener("message", function(e) {
		if (e.data.target == null || e.data.target == conn.name) {
			conn.onMessage(e.data);
		}
	}, false);
}
CrossScriptConnection.prototype.send = function(target, name, data) {
	var data = {
		sender: this.name,
		target: target,
		name: name,
		data: data,
	};
	window.postMessage(data, "*");
};
CrossScriptConnection.prototype.addListener = function(evtName, fn) {
	if (!this.listeners[evtName]) {
		this.listeners[evtName] = [];
	}
	this.listeners[evtName].push(fn);
};
CrossScriptConnection.prototype.onMessage = function(evt) {
	var listeners = this.listeners[evt.name];
	if (listeners != null) {
		for (var i=0;i<listeners.length;i++) {
			try {
				listeners[i](evt);
			} catch(e) {
				console.error(e);
			}
		}
	}
};
